import java.awt.Container;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;

import graph.*;
import dijkstra.*;

public class BABRoutenplanerGUI extends JFrame {

  // Anfang Attribute
  private JLabel lbStart = new JLabel();
  private JComboBox<String> cbStart = new JComboBox<String>();
    private DefaultComboBoxModel<String> cbStartModel = new DefaultComboBoxModel<String>();
  private JLabel lbZiel = new JLabel();
  private JComboBox<String> cbZiel = new JComboBox<String>();
    private DefaultComboBoxModel<String> cbZielModel = new DefaultComboBoxModel<String>();
  private JTextArea taRoute = new JTextArea("");
    private JScrollPane taRouteScrollPane = new JScrollPane(taRoute);
  private JButton bRouteSuchen = new JButton();
  private BABGraph graphAutobahnen;
  private Dijkstra dij;
  // Ende Attribute

  /**
   * Launch the application.
   */
  public static void main(String[] args) {
    EventQueue.invokeLater(new Runnable() {
      public void run() {
        try {
          BABRoutenplanerGUI frame = new BABRoutenplanerGUI();
          frame.setVisible(true);

        } catch (Exception e) {
          e.printStackTrace();
        }
      }
    });
  }

  /**
   * Create the frame.
   */
  public BABRoutenplanerGUI() {
    setSize(463, 469);
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten
    lbStart.setBounds(16, 16, 38, 20);
    lbStart.setText("Start");
    cp.add(lbStart);
    cbStart.setModel(cbStartModel);
    cbStart.setBounds(56, 16, 150, 20);
    cp.add(cbStart);
    lbZiel.setBounds(224, 16, 30, 20);
    lbZiel.setText("Ziel");
    cp.add(lbZiel);
    cbZiel.setModel(cbZielModel);
    cbZiel.setBounds(256, 16, 150, 20);
    cp.add(cbZiel);
    taRouteScrollPane.setBounds(16, 48, 400, 332);
    cp.add(taRouteScrollPane);
    bRouteSuchen.setBounds(16, 392, 115, 25);
    bRouteSuchen.setText("Route suchen");
    bRouteSuchen.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        bRouteSuchen_ActionPerformed(evt);
      }
    });
    cp.add(bRouteSuchen);
    setResizable(false);
    this.setVisible(true);
    graphLaden();
  }
    // Ende Komponenten
  // Anfang Methoden

  
  public void graphLaden(){
    graphAutobahnen = new BABGraph();
    dij = new Dijkstra(graphAutobahnen);
    List<String> abAuffahrten = graphAutobahnen.gibAufAbfahrten();
    abAuffahrten.toFirst();
    while (abAuffahrten.hasAccess()) {
        cbStart.addItem(abAuffahrten.getContent());
        cbZiel.addItem(abAuffahrten.getContent());
        abAuffahrten.next();
    }
    taRoute.append("Autobahnen wurden geladen");
  }

  public String ausgabeErzeugenEinfach(List<DijkstraVertex> route) {
    route.toFirst();
    String ausgabe = "";
    while (route.hasAccess()) {
        ASVertex asV = (ASVertex) route.getContent();
        String babNr = asV.gibBABNr();
        String abfahrtName = asV.getID();
        ausgabe = ausgabe + babNr + "" + abfahrtName+"\n";
        route.next();
    }
    double weglaenge = dij.gibWeglaenge();
    weglaenge = Math.round(weglaenge*10)/10;
    String wegString = String.format("Fahrtstrecke: %.1f km",weglaenge);
    ausgabe = ausgabe+wegString;
    return ausgabe;
  }
  
  public String ausgabeErzeugen(List<DijkstraVertex> route) {
    ASVertex asV;
    String babNr;
    String abfahrtName;
    route.toFirst();
    double weglaenge = 0;
    String ausgabe="";
    if (!route.hasAccess()) {
      ausgabe = "Keine Route gefunden";
    } else {
      asV =  (ASVertex)route.getContent();
      babNr = asV.gibBABNr();
      abfahrtName = asV.getID();
      ausgabe = "Auffahren A" + babNr + " " + abfahrtName;
      route.next();
      asV = (ASVertex) route.getContent();
      if (asV != null) {
        ausgabe = ausgabe + " Richtung " + asV.getID() + "\n";
        while (route.hasAccess()) {
          abfahrtName = asV.getID();
          if (asV instanceof KreuzVertex) {
              route.next();
              if (route.hasAccess()) {
                asV = (ASVertex) route.getContent();
                String bab2 = asV.gibBABNr();
                      String richtung = asV.getID();
                      if (!babNr.equals(bab2)) {
               ausgabe = ausgabe + "A" + babNr + " "+ abfahrtName + " auf die A" + bab2+ " Richtung " + richtung + "\n";
               babNr = bab2;
                } else {
               ausgabe = ausgabe + "A" + babNr + " "
                   + abfahrtName + "\n";
                }
              } else {
                 String richtung = "Abfahrt";
                 weglaenge = dij.gibWeglaenge();
              }
          } else {
            route.next();
            if (route.hasAccess()) {
              asV = (ASVertex) route.getContent();
                        } else {
                            weglaenge = dij.gibWeglaenge();
                            
                        }
          }
        }
        babNr = asV.gibBABNr();
        abfahrtName = asV.getID();
        String asNr = ((ASVertex)asV).gibASNr();
        ausgabe = ausgabe + "Abfahren A" + babNr + " " + abfahrtName
            + " AS" + asNr + "\n";
        weglaenge = Math.round(weglaenge * 10) / 10;
        String wegString = String.format("Fahrstrecke: %.1f km",
            weglaenge);
        ausgabe = ausgabe + wegString;
      }
    }
    return ausgabe;
  }
  
  /**
   * Berechnet mithilfe des Dijkstra-Algorithmus' den kuerzesten Weg zwischen 
   * der eingegebenen Auffahrt und der eingegebenen Abfahrt,
   * sofern passende Knoten im Graphen gefunden werden. 
   * Anschliessend wird ein Text zur Beschreibung der Route formatiert und ausgegeben
   */
  public void bRouteSuchen_ActionPerformed(ActionEvent evt) {
    String startAS = ((String)cbStart.getSelectedItem()).trim();
    String zielAS = ((String)cbZiel.getSelectedItem()).trim();
    DijkstraVertex sV = (DijkstraVertex)graphAutobahnen.getVertex(startAS);
    DijkstraVertex zV = (DijkstraVertex)graphAutobahnen.getVertex(zielAS);
    dij.sucheWeg(sV, zV);
    List<DijkstraVertex> route = dij.gibRoute();
    String wegbeschreibung = ausgabeErzeugen(route);
    taRoute.setText(wegbeschreibung);
  } // end of bRouteSuchen_ActionPerformed
  // Ende Methoden
}
